/*
    Copyright (c) 2007, Ben

    All rights reserved.
    Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    *   Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    *   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer 
	    in the documentation and/or other materials provided with the distribution.
    *   The names of its contributors may be used to endorse or promote products derived from this software without specific prior 
	    written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
    LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

/*
 * ServerInfo class specification. Contains information about servers such as their name, address, port and 
 * how many times we've connected to it.
 */

#ifndef SERVERINFO_H
#define SERVERINFO_H

#include <string>
using namespace std;

class ServerInfo {
	public:
		ServerInfo(string name, string address, int port);
		ServerInfo(string line);
		string getName() const;
		string getAddress() const;
		const int getPort() const;
		void setPort(int port);
		void setName(string name);
		void setAddress(string address);
		int getConnectionCount() const;
		void setConnectionCount(int connectionCount); 
		string serialize();
	
	 private:
		string name;
		string address;
		int port;
		int connectionCount;
};

#endif